{**************************************************}
{**                                              **}
{** Program til at Kode Beskeder til en kode der **}
{** kan sendes som E-mail                        **}
{**                                              **}
{**                                              **}
{** V3.0                                         **}
{** Lavet sdan at den laverbeskeder om hvad det **}
{** er der har lavet filen KODET.TXT             **}
{** v3.1                                         **}
{** Idiotsikker indlsning                       **}
{** v3.2                                         **}
{** Sikker indlsning, med nsten alle formater  **}
{** v4.0                                         **}
{** Koder fra og til Fil, men kun .TXT filer     **}
{** v4.1                                         **}
{** Kosmetiske Rettelser                         **}
{** v4.2                                         **}
{** Kan lse alle typer Filer                    **}
{** v5.0                                         **}
{** Kan lse alle typer, men ikke i Dekod Besked **}
{** v6.0                                         **}
{** Laver programmet om til commandline, for at  **}
{** For at det virker under Windows 8.1, og 10   **}
{** V7.0                                         **}
{** Kan fremstille data file der kan vedhftes   **}
{** V7.1                                         **}
{** Tilrettet til at virker under Linux (Ubuntu) **}
{** I Ubuntu kan ikke bruges F2 til at stoppe    **}
{** Skiftet til at stoppe med \ (BackSlash)      **}
{**                                              **}
{**************************************************}
{$I-}

Uses   crt,Dos;

Const
  Ver : String[4] = '7.1';


Var

Work,A      : Char;
Work2       : Byte;
Bogst       : Byte;
Nib1        : Byte;
Nib2        : Byte;
Kode        : String;
StKode      : Integer;
Kodecounter : Integer;
Parameter   : String;
Count       : Integer;
Work1,Et    : Boolean;
Kodefil     : Text;
Valg        : Byte;
ParStr       : Boolean;

   Procedure Top;
   {**************************************************}
   {**                                              **}
   {** Del der Skriver top paa Skaermen             **}
   {**                                              **}
   {**************************************************}

   Begin
       GotoXY(1,1);
       clrscr;
       writeln('Kodbesked ',Ver);
       WriteLn;
   End;


   Procedure Working(x : byte; b : byte);
   {**************************************************}
   {**                                              **}
   {** Del der laver roterende tegn paa skaerm      **}
   {**                                              **}
   {**************************************************}
   Var
     y: Byte;
   Begin
   y := WhereY;
   GotoXY(x,y-1);
   Case b of
       1: Begin
            Writeln('/');
          end;
       2: Begin
            Writeln('|');
          end;
       3: Begin
            Writeln('\');
          end;
       4: Begin
            Writeln('-');
          end;
      end;
   end;

   Procedure MainMenu;
   {**************************************************}
   {**                                              **}
   {** Del der Skriver Menuen p skrmen            **}
   {**                                              **}
   {**************************************************}


   Begin
      Top;
      WriteLn('1. Kod Besked     ');
      WriteLn('2. Dekod Besked   ');
      WriteLn('3. Kod fra Fil    ');
      WriteLn('4. Dekod til Fil  ');
      WriteLn('5. Konverter til data');
      WriteLn('6. Konverter fra data');
      WriteLn('7. Afslut         ');
      WriteLn;
      WriteLn(' Tryk tallet for at bruge menupunkt');
      WriteLn;
   End;




   Procedure GenKod;
   {**************************************************}
   {**                                              **}
   {** Del der Laver data om til Ren text fil       **}
   {**                                              **}
   {**************************************************}

   Var
      Rekodlaes  : Text;
      ReKodSkriv : Text;
      Raekke     : Integer;
      Mellem     : String[4];
      Tal        : Integer;
      A          : Integer;
      Counter    : integer;
      Sign       : byte;

   Begin
     Counter := 1;

     WriteLn('Genkoder: ');

     {bner Filer}
     Assign(RekodLaes,'NEWFILE.$$$');
     Assign(RekodSkriv,'KODET.TXT');
     Reset(ReKodLaes);
     ReWrite(RekodSkriv);

     Readln(ReKodLaes,Mellem); {Lser filtype}

     If Mellem = 'TXT' then {Hvilken type Fil}
        Mellem := 'ID0'
     Else
        Mellem := 'ID1';

     WriteLn (RekodSkriv,'Kopier ALT fra og med denne linje indtil STOP ind i en fil ved navn KODET.TXT');
     WriteLn (RekodSkriv,'');
     WriteLn (RekodSkriv,'Denne besked er kodet med Kodbesked ',Ver);
     WriteLn (RekodSkriv,'');
     WriteLn (RekodSkriv,'Kodet besked Start!');
     WriteLn (RekodSkriv,'-------------------------------------------------------------'+ Mellem);


     Raekke := 1;

     {Laver rkkerne af tallene i den kodede fil}
     Repeat
       {Laver bevgelse}
        Counter := Counter +1;
        If Counter > 1000 then
        Begin
          Counter := 0;
          sign := sign + 1;
          if sign > 4 then sign := 1;
          Working(11,sign);
        end;

       Readln(ReKodLaes,Mellem);
       Val(Mellem,Tal,A);
       Str(tal,Mellem);
       While Length(Mellem) < 4 Do
          Begin
            Mellem := Mellem + ' ';
          End;
       If Raekke < 20 then
          Write(RekodSkriv,Mellem)
       Else
          Begin
            WriteLn(RekodSkriv,Mellem);
            Raekke := 0;
          End;
       Raekke := Raekke + 1;
     Until EOF(ReKodLaes);


     WriteLn (RekodSkriv,'');
     WriteLn (RekodSkriv,'----------------------------------------------------------------');
     WriteLn (RekodSkriv,'Kodet besked slut!');
     WriteLn (RekodSkriv,'');
     WriteLn (RekodSkriv,'Genereret med Kodbesked ',Ver,' lavet af Brian Hansen');
     WriteLn (RekodSkriv,'');
     WriteLn (RekodSkriv,'STOP');


     Close(ReKodLaes);
     Close(RekodSkriv);
   End;





   Procedure KodBesked;
   {**************************************************}
   {**                                              **}
   {** Del der Koder beskeden, der skal indtastes   **}
   {** en kode.                                     **}
   {**                                              **}
   {**************************************************}
   Var
   Stop   : Boolean;


   Begin

     Write('Indtast Kode : ');
     ReadLn (Kode);

     WriteLn ('Indtast beskeden, der skal kodes. Afslut med \ (BackSlash):');
     WRiteLn;



     Kodecounter := 0;
     Stop := False;
     StKode := Length(Kode);

     Assign(Kodefil, 'NEWFILE.$$$');
     Rewrite(Kodefil);
     WriteLn(KodeFil,'TXT');
     Repeat
        Kodecounter := Kodecounter + 1;
        If Kodecounter > StKode then
           Kodecounter := 1;
        Work := Readkey;
{        If Work = Chr(0)Then
           Begin
              Work := Readkey;
              If Work = '<' Then Stop := True;
           End; **** Fjernet virker ikke under Linux****}
         If Work = '\' Then Stop := True;
        If not Stop Then
        Begin
           Work2 := ord(Work);
           Bogst := Ord(Kode[Kodecounter]);
           Work2 := Work2 xor Bogst;
           Nib1 := Work2 and 240;
           Nib2 := Work2 and 15;
           Write(Work);
           Nib1 := 65+Nib1;
           Nib2 := 65+Nib2;
           WriteLn(Kodefil,Nib1);
           WriteLn(Kodefil,Nib2);
           If Work = Chr(13) then
           Begin
              Kodecounter := Kodecounter + 1;
              If Kodecounter > StKode then Kodecounter := 1;
              Work := chr(10);
              Work2 := ord(Work);
              Bogst := Ord(Kode[Kodecounter]);
              Work2 := Work2 xor Bogst;
              Nib1 := Work2 and 240;
              Nib2 := Work2 and 15;
              Write(Work);
              Nib1 := 65+Nib1;
              Nib2 := 65+Nib2;
              WriteLn(Kodefil,Nib1);
              WriteLn(Kodefil,Nib2);
           End;
        End;
     Until Stop;

     Close(Kodefil);

     GenKod; {Lav den endelige kodning}

   End;



   Procedure Indlaes;
   {**************************************************}
   {**                                              **}
   {** Del der idlser ren fil og laver den om til  **}
   {** $$$ fil                                      **}
   {**                                              **}
   {**************************************************}
   Var
   Rekodlaes  : Text;
   ReKodSkriv : Text;
   Mellem     : String[4];
   MellemFil  : String;
   NoSpace    : String[4];
   Tal        : Integer;
   A,B        : Integer;
   Stop       : Boolean;
   FilType    : String[3];
   Counter    : integer;
   Sign       : byte;


   Begin

     Stop := False;
     {**Reenkode Filen S dekoder kan bruge det**}

     WriteLn ('Indlser kodet fil:');


     Assign(RekodLaes,'KODET.TXT');
     Assign(RekodSkriv,'NEWFILE.$$$');
     Reset(ReKodLaes);
     ReWrite(RekodSkriv);

     Repeat
       ReadLN(ReKodLaes,MellemFil);
       FilType := MellemFil; {Lser indtil den rammer frste indikation p kode}
     Until FilType = '---';

     {Finder ud af om det var en "Normal" filtype, eller en der kan indeholde data}
     FilType[1] := MellemFil[Length(MellemFil)-2];
     FilType[2] := MellemFil[Length(MellemFil)-1];
     FilType[3] := MellemFil[Length(MellemFil)-0];
     If FilType = 'ID0' then
        WriteLn(rekodSkriv,'TXT')
     Else
        WriteLn(rekodSkriv,'DAT');

     Repeat
       ReadLN(ReKodLaes,MellemFil);
       If MellemFil <> '----------------------------------------------------------------' Then
       Begin
          If MellemFil = '' then
             ReadLN(ReKodLaes,MellemFil);
          If MellemFil = '----------------------------------------------------------------' Then
             Stop := True; {er man net til sidste kodelinje?}

       {Laver bevgelse}
        Counter := Counter +1;
        If Counter > 1000 then
        Begin
          Counter := 0;
          sign := sign + 1;
          if sign > 4 then sign := 1;
          Working(21,sign);
        end;

          If Not Stop Then
          For b := 0 to 19 Do
            Begin
              If 4*b+1 < Length(MellemFil) Then
              Begin
                Mellem := Copy(MellemFil,4*b+1,4);
                NoSpace := '';
                For a := 1 to 4 Do
                  If (Mellem[a] > '/') and (Mellem[a] < ':') then
                      NoSpace := NoSpace + Mellem[a];
                Mellem := NoSpace;
                Val(Mellem,Tal,A);
                Str(tal,Mellem);
                WriteLn(ReKodSkriv,Mellem);
              End;
            End;

       End
       else
          Stop := True;
     Until EOF(ReKodLaes) or Stop;
     WriteLn;
     Close(ReKodLaes);
     Close(RekodSkriv);

   End;




   Procedure DekodBesked;
   {**************************************************}
   {**                                              **}
   {** Del der Dekoder besked. Der skal indtastes   **}
   {** en kode.                                     **}
   {**                                              **}
   {**************************************************}
   Var
   c          : Char;
   FilType    : String[3];


   Begin

     IndLaes; {Henter data, og gr klar til dekodning}



     Assign(Kodefil, 'NEWFILE.$$$');
     Reset(Kodefil);

     ReadLn(KodeFil,FilType);{Filtype: TXT eller andet}

     If FilType = 'DAT' Then
        Begin

           WriteLn ('Ikke REN TXT Fil. Brug Dekod til Fil. Tryk en tast');

           Repeat
           Until Keypressed;
           c := Readkey;
           If (c = chr(0)) then c := ReadKey;
           Exit;
        End;


     Write('Idtast Kode: ');
     ReadLn(Kode);
     WriteLn('Dekoder   ');
     Kodecounter := 0;
     StKode := Length(Kode);

     repeat
        Kodecounter := Kodecounter + 1;
        If Kodecounter > StKode then
           Kodecounter := 1;
        ReadLn(Kodefil,Nib1);
        ReadLn(Kodefil,Nib2);
        Nib1 := Nib1 - 65;
        Nib2 := Nib2 - 65;
        Work2 := 0;
        Work2 := Work2 Or Nib1;
        Work2 := Work2 Or Nib2;
        Bogst := Ord(Kode[Kodecounter]);
        Work2 := Work2 xor Bogst;
        Write(Chr(Work2));
     Until eof(Kodefil);

     Close(Kodefil);

     WRiteLn;
     WriteLn('Dekodning frdig. Tryk en tast');
     Repeat
     Until Keypressed;
     c := Readkey;
     If (c = chr(0)) then c := ReadKey;


   End;


   Procedure KodFil;
   {**************************************************}
   {**                                              **}
   {** Del der Koder en fil. Der skal indtastes et  **}
   {** Filnavn og en kode                           **}
   {**                                              **}
   {**************************************************}
   Var
   a          : Char;
   OrgFil     : File of char;
   FilNavn    : String;
   FilLang    : LongInt;
   DirInfo    : SearchRec;
   FilCount   : LongInt;
   Mellem     : String;
   I          : Integer;
   FileType   : String[3];
   Y          : Byte; {Curser Y Position}
   Counter    : integer;
   Sign       : byte;

   Begin
     Counter := 0;
     Sign := 1;
     FileType := '   ';
     WriteLn;
     Write('Indtast kode : ');
     ReadLn (Kode);
     Write('Indtast Filnavn  : ');

     ReadLn(FilNavn);

     {De sidste 3 af FilNavn er Filtype}
     FileType[1] := Filnavn[Length(Filnavn)-2];
     FileType[2] := Filnavn[Length(Filnavn)-1];
     FileType[3] := Filnavn[Length(Filnavn)-0];

     For i := 1 to 3 do
        FileType[i] := Upcase(FileType[i]);

     WRiteLn('Koder Fil ');

     Kodecounter := 0;
     StKode := Length(Kode);

     Assign(OrgFil,FilNavn);
     Reset(OrgFil);

     If IOResult <> 0 Then
       Begin
          WriteLn(Filnavn,' Blev ikke Fundet!!');

          Repeat
          Until Keypressed;
          a := Readkey;
          If (a = chr(0)) then a := ReadKey;
          Exit;
       End;


     FindFirst(FilNavn,Archive,DirInfo);
     FilLang := Dirinfo.Size;
     FilCount := 0;


     Assign(Kodefil, 'NEWFILE.$$$');
     Rewrite(Kodefil);
     Writeln(Kodefil,FileType);
     WriteLn('Koder : ');
     Y:=WhereY;
     Repeat
        FilCount := FilCount + 1;
        Kodecounter := Kodecounter + 1;
        If Kodecounter > StKode then Kodecounter := 1;
        Counter := Counter +1;
        If Counter > 1000 then
        Begin
          Counter := 0;
          sign := sign + 1;
          if sign > 4 then sign := 1;
          Working(9,sign);
        end;
        Read(OrgFil,Work);
        Work2 := ord(Work);
        Bogst := Ord(Kode[Kodecounter]);
        Work2 := Work2 xor Bogst;
        Nib1 := Work2 and 240;
        Nib2 := Work2 and 15;
        Nib1 := 65+Nib1;
        Nib2 := 65+Nib2;
        WriteLn(Kodefil,Nib1);
        WriteLn(Kodefil,Nib2);
        Str(FilCount,Mellem);
        Counter := Counter + 1;

     Until FilCount = FilLang;

     Close(Kodefil);
     Close(OrgFil);

     GenKod; {Laver det til en "normal" txt fil}

     WriteLn;
     WriteLn('Kodning frdig. Tryk en tast');

     Repeat
     Until Keypressed;
     a := Readkey;
     If (a = chr(0)) then a := ReadKey;


   End;




   Procedure DeKodFil;
   {**************************************************}
   {**                                              **}
   {** Del der deKoder en fil. Der skal indtastes et**}
   {** Filnavn og en kode                           **}
   {**                                              **}
   {**************************************************}
   Var
   ClearTxt   : Text;
   MellemFil  : String;
   c          : Char;
   FilNavn    : String;
   FilType    : String[3];
   FilCount   : Longint;
   Y          : Byte; {Y position af curser}
   Counter    : integer;
   Sign       : byte;

   Begin


     IndLaes;

     WriteLn;
     Write('Indtast kode : ');
     ReadLn(Kode);

     Write('Indtast Fil  : ');

     REadLn(FilNavn);



     Assign(Kodefil, 'NEWFILE.$$$');
     Assign(ClearTxt,FilNavn);
     Reset(Kodefil);
     Rewrite(ClearTxt);

     ReadLn(KodeFil,FilType);


     WriteLn('Dekoder : ');
     Y:=WhereY;

     Kodecounter := 0;
     FilCount := 0;
     Counter := 0;
     StKode := Length(Kode);


     repeat
        Kodecounter := Kodecounter + 1;
        FilCount := FilCount + 1;
        If Kodecounter > StKode then Kodecounter := 1;
        Counter := Counter +1;
        If Counter > 1000 then
        Begin
          Counter := 0;
          sign := sign + 1;
          if sign > 4 then sign := 1;
          Working(11,sign);
        end;
        ReadLn(Kodefil,Nib1);
        ReadLn(Kodefil,Nib2);
        Nib1 := Nib1 - 65;
        Nib2 := Nib2 - 65;
        Work2 := 0;
        Work2 := Work2 Or Nib1;
        Work2 := Work2 Or Nib2;
        Bogst := Ord(Kode[Kodecounter]);
        Work2 := Work2 xor Bogst;
        Write(ClearTxt,Chr(Work2));
        Str(FilCount,MellemFil);

     Until eof(Kodefil);

     Close(Kodefil);
     Close(ClearTxt);
     WriteLn;
     WriteLn('Dekodning frdig. Tryk en tast');


     Repeat
     Until Keypressed;
     c := Readkey;
     If (c = chr(0)) then c := ReadKey;


   End;



Procedure MakeData;
{**************************************************}
{**                                              **}
{** Del der konverterer til ren datafil, kan     **}
{** vedhftes                                    **}
{**                                              **}
{**************************************************}
Var
 ClearTxt   : Text;
 MellemFil  : String;
 c          : Char;
 FilNavn    : String;
 FilType    : String[3];
 FilCount   : Longint;
 Y          : Byte; {Y position af curser}
 Counter    : Integer;
 Sign       : Byte;
 Begin



   WriteLn;
   Write('Indtast Fil  : ');

   REadLn(FilNavn);



   Assign(Kodefil,'NEWFILE.$$$');
   Assign(ClearTxt,FilNavn);
   Reset(Kodefil);
   Rewrite(ClearTxt);

   ReadLn(KodeFil,FilType);


   WriteLn('Genkoder: ');



   FilCount := 0;
   Counter := 0;



   repeat
     Counter := Counter + 1;
     If Counter > 1000 then
        Begin
          Counter := 0;
          sign := sign + 1;
          if sign > 4 then sign := 1;
          Working(11,sign);
        end;

      FilCount := FilCount + 1;
      ReadLn(Kodefil,Nib1);
      ReadLn(Kodefil,Nib2);
      Write(ClearTxt,Chr(Nib1));
      Write(ClearTxt,Chr(Nib2));
      Str(FilCount,MellemFil);

   Until eof(Kodefil);

   Close(Kodefil);
   Close(ClearTxt);
   WriteLn;
   WriteLn('Omkodning frdig. Tryk en tast');


   Repeat
   Until Keypressed;
   c := Readkey;
   If (c = chr(0)) then c := ReadKey;
   MainMenu;

 end;


Procedure ConvData;
{**************************************************}
{**                                              **}
{** Del der laver ren datafil tilbage til ren txt**}
{**                                              **}
{**                                              **}
{**************************************************}
Var
 ClearTxt   : Text;
 KodTxt     : Text;
 Mellem     : String;
 c          : Char;
 b          : Byte;
 FilNavn    : String;
 FilCount   : Longint;
 Y          : Byte; {Y position af curser}
 Counter    : Integer;
 Sign       : Byte;
 Begin

  WriteLn;
   Write('Indtast Fil  : ');

   ReadLn(FilNavn);

   Assign(ClearTxt,'NEWFILE.$$$');
   Assign(KodTxt,FilNavn);
   Reset(KodTxt);
   Rewrite(ClearTxt);

   WriteLn('Forbereder: ');

   FilCount := 0;
   Counter := 0;

   WriteLn(ClearTxt,'DAT');

   repeat
     Counter := Counter + 1;
     If Counter > 1000 then
        Begin
          Counter := 0;
          sign := sign + 1;
          if sign > 4 then sign := 1;
          Working(13,sign);
        end;

      FilCount := FilCount + 1;
      Read(KodTxt,c);
      b := ord(c);
      Str(b,mellem);
      WriteLn(ClearTxt,mellem);

   Until eof(KodTxt);

   Close(Kodtxt);
   Close(ClearTxt);

   GenKod; {genererer kodet.txt}

   WriteLn;
   WriteLn('Omkodning frdig. Tryk en tast');


   repeat
   Until Keypressed;
   c := Readkey;
   If (c = chr(0)) then c := ReadKey;


 end;



{**************************************************}
{**                                              **}
{** Main! Hovedprogramdel                        **}
{**                                              **}
{**************************************************}



Begin


  ParStr := False;

  Parameter := Paramstr(1);
  For Count := 1 to Length(Paramstr(1)) Do
     Parameter[Count] := Upcase(Parameter[Count]);

  If Parameter = 'KOD' Then
    Begin
      KodBesked;
      ParStr := True;
    End;

  If Parameter = 'DEKOD' Then
    Begin
      DekodBesked;
      ParStr := True;
    End;

  If Parameter = 'KODFIL' Then
    Begin
      KodFil;
      ParStr := True;
    End;

  If Parameter = 'DEKODFIL' Then
    Begin
      DekodFil;
      ParStr := True;
    End;


  Valg := 1;
  Work1 := True;
  {***** Herfra og frem, valg af menu ********}
  If Not Parstr then
  Repeat
    MainMenu;

    Et := True;
    A := ReadKey;
    If a = #0 then
      Begin
        A := ReadKey;

        If a = #59 then
        Begin
          gotoxy(1,1);
          WriteLn('KodBesked ',Ver);
          WriteLn('Lavet af Brian hansen');
          WriteLn;
          Repeat
          Until Keypressed;
          a := Readkey;
          If (a = chr(0)) then a := ReadKey;


        End;
      End;
         { ABout;}

        Case A Of
         '1' : KodBesked;
         '2' : DeKodBesked;
         '3' : Kodfil;
         '4' : DeKodfil;
         '5' : MakeData;
         '6' : ConvData;
        End;



      If a <> '7' then a := #1;

  Until A = '7';


End.
